// ------------------------------------------------------------------------------
// Springs - http://www.arkitus.com
// Copyright (C) 2005  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Spring.java
// Something that connects two springs together.
// ------------------------------------------------------------------------------

class Spring
{
  int o1;
  int o2;
  float l;
  
  Spring( int O1, int O2, float L )
  {
    o1 = O1;
    o2 = O2;
    l = L;
  }
  
  void pull()
  {
    float x1 = Objects[o1].x;
    float y1 = Objects[o1].y;
    float x2 = Objects[o2].x;
    float y2 = Objects[o2].y;
    
    float deltax = x2 - x1;
    float deltay = y2 - y1;
    
    if ( deltax == 0 )
    {
      deltax = random(-10,10);
    }
    if ( deltay == 0 )
    {
      deltay = random(-10,10);
    }
    
    float d = sqrt(pow(deltax,2)+pow(deltay,2));
    float theta = atan2(deltay, deltax);
    
    float extensionx = (d - l*fl)*cos(theta);
    float extensiony = (d - l*fl)*sin(theta);
    
    Objects[o1].tx += +fr*extensionx/2;
    Objects[o1].ty += +fr*extensiony/2;
    Objects[o2].tx += -fr*extensionx/2;
    Objects[o2].ty += -fr*extensiony/2;
  }
  
  void display()
  {
    stroke(150,150,150);
    strokeWeight(2);
    line(Objects[o1].x, Objects[o1].y, Objects[o2].x, Objects[o2].y);
  }
}
