import processing.core.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class Springs extends PApplet {// ------------------------------------------------------------------------------
// Springs - http://www.arkitus.com
// Copyright (C) 2005  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Springs.java
// Procedures related to starting up the program and adjusting the settings
// are in this file.
// ------------------------------------------------------------------------------

int num_s;
int num_o;
int num_p;

float fb = 0.9f;             // Bounce constant.
float fk = 0.1f;             // Friction constant.
float fr;                   // Spring constant.
float fg;                   // Gravity constant.
float fd;                   // Damping constant.
float fl;                   // Length constant.

Spring[] Springs;           // Create spring array.
Object[] Objects;           // Create object array.  
HScroller LengthS;          // Create scrollers.
HScroller GravityS;         // Create scrollers.
HScroller SpringS;          // Create scrollers.
HScroller DampingS;         // Create scrollers.

PFont font; 


public void setup()
{
  // Applet Settings
  
  size(800,420);
  framerate(30);
  smooth();
  font = loadFont("Verdana-10.vlw"); 
  textFont(font, 10); 

  // Create Scrollers
  
  LengthS = new HScroller(0.2f, 1.5f, 1, 700, 310, 50);
  GravityS = new HScroller(-1, 10, 4, 700, 330, 50);
  SpringS = new HScroller(0.2f, 5, 3.5f, 700, 350, 50);
  DampingS = new HScroller(0.1f, 0.95f, 0.8f, 700, 370, 50);
    
  // Create Objects
  
  num_o = 18;          
  Objects = new Object[num_o];
  
  Objects[0] = new Object(200, 210, 5, 1);
  Objects[1] = new Object(200, 210, 5, 1);
  Objects[2] = new Object(200, 210, 5, 1);
  Objects[3] = new Object(200, 210, 5, 1);
  
  Objects[4] = new Object(400, 210, 5, 1);
  Objects[5] = new Object(400, 210, 5, 1);
  Objects[6] = new Object(400, 210, 5, 1);
  
  Objects[7] = new Object(600, 210, 5, 1);
  Objects[8] = new Object(600, 210, 5, 1);
  Objects[9] = new Object(600, 210, 5, 1);
  Objects[10] = new Object(600, 210, 5, 1);
  Objects[11] = new Object(600, 210, 5, 1);  
  
  Objects[12] = new Object(300, 250, 5, 0);  
  Objects[13] = new Object(500, 250, 5, 0);  
  
  Objects[14] = new Object(400, 50, 5, 1);  
  Objects[15] = new Object(400, 50, 5, 1);  
  Objects[16] = new Object(400, 50, 5, 1);  
  Objects[17] = new Object(400, 50, 5, 0);  
  
  // Create springs
  
  num_s = 24;
  Springs = new Spring[num_s];

  Springs[0] = new Spring(0,1,100);
  Springs[1] = new Spring(1,2,100);
  Springs[2] = new Spring(2,3,100);
  Springs[3] = new Spring(3,0,100);
  Springs[4] = new Spring(1,3,100);
  Springs[5] = new Spring(2,0,100);
  
  Springs[6] = new Spring(4,5,50);
  Springs[7] = new Spring(5,6,50);
  Springs[8] = new Spring(6,4,50);
  
  Springs[9] = new Spring(7,8,100);
  Springs[10] = new Spring(8,9,100);
  Springs[11] = new Spring(9,10,100);
  Springs[12] = new Spring(10,11,100);
  Springs[13] = new Spring(11,7,100);
  Springs[14] = new Spring(11,8,50);
  Springs[15] = new Spring(11,9,50);
  Springs[16] = new Spring(10,8,50);
  Springs[17] = new Spring(10,7,50);
  Springs[18] = new Spring(9,7,50);
  
  Springs[19] = new Spring(5,13,100);
  Springs[20] = new Spring(6,12,100);
  
  Springs[21] = new Spring(14,15,50);
  Springs[22] = new Spring(15,16,50);
  Springs[23] = new Spring(16,17,50);
}

public void draw()
{
  background(255,255,255);
  
  for ( int i=0; i<num_s; i++ )
  {
    Springs[i].pull();
  }
   
  for ( int i=0; i<num_o; i++ )
  {
    Objects[i].bounce();
    Objects[i].drag();
    Objects[i].fall();
    Objects[i].move();
  }
  
  for ( int i=0; i<num_s; i++ )
  {
    Springs[i].display();
  }
  
  for ( int i=0; i<num_o; i++ )
  {
    Objects[i].display();
  }
  
  fl = LengthS.update();
  fg = GravityS.update();
  fr = SpringS.update();
  fd = DampingS.update();
  
  fill(100,100,100);
  text("l", 760,312);
  text("g", 760,332);
  text("k", 760,352);
  text("b", 760,372);
}

public void mousePressed()
{
  for ( int i=0; i<num_o; i++ )
  {
    Objects[i].checkClick();
  }
}

// ------------------------------------------------------------------------------
// Springs - http://www.arkitus.com
// Copyright (C) 2005  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// HScroller.java
// A GUI element used to adjust various settings such as gravity or bounce k.
// ------------------------------------------------------------------------------

class HScroller
{
  float min;
  float max;
  float def;
  float x;
  float y;
  float xpos;
  float w;
  float scale;
  float value;
  boolean locked;
  
  HScroller( float Min, float Max, float Default, float X, float Y, float W )
  {
    min = Min;
    max = Max;
    x = X;
    y = Y;
    w = W;
    
    scale = ( max - min ) / w;
    def = ( Default - min ) / scale;
    xpos = def;
  }
  
  public float update()
  {
    drag();
    display();
    readValue();
    
    return value;
  }
  
  public void drag()
  {
    if ( mousePressed && over() )
    {
      locked = true;
    }
    if ( !mousePressed )
    {
      locked = false;
    }
    if ( locked )
    {
      assignPos(mouseX-x);
    }
  }
  
  public void assignPos( float X )
  {
    xpos = X;
    
    if ( X > w )
    {
      xpos = w;
    }
    if ( X < 0 )
    {
      xpos = 0;
    }
  }
  
  public void readValue()
  {
    value = xpos*scale + min;
  }
  
  public void display()
  {
    noSmooth();
    stroke(200,200,200);
    fill(230,230,230);
    strokeWeight(1);
    line(x,y,x+w,y);
    line(x+def, y-2, x+def, y+2);
    rectMode(CENTER);
    stroke(100,100,100);
    rect(x+xpos, y, 5, 5);
    smooth();
  }
  
  public boolean over() 
  { 
    if( mouseX > x - 10 && mouseX < x + w + 10 && mouseY > y - 10 && mouseY < y + 10 ) 
    { 
      return true; 
    } 
    else
    { 
      return false; 
    } 
  }
}

// ------------------------------------------------------------------------------
// Springs - http://www.arkitus.com
// Copyright (C) 2005  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Object.java
// Something that gets connected to another object by a spring.
// ------------------------------------------------------------------------------

class Object
{
  float x;
  float y;
  float m;
  float r;
  float f;
  float wx;
  float wy;
  float tx;
  float ty;
  float vx;
  float vy;
  boolean locked;
  
  Object( float X, float Y, float M, float F )
  {
    x = abs(X);
    y = abs(Y);
    m = M;
    r = M;
    f = F;
    
    tx = ty = vx = vy = 0;
    locked = false;
  }
  
  public void display()
  {
    stroke(0,0,0);
    strokeWeight(3);
    fill(100+f*155, 100+f*155, 100+f*155);
    ellipse(x,y,2*r,2*r);
  }
  
  public void bounce()
  {
    // Bounce off the walls
    if ( y + vy + r > height-3 && vy > 0 )
    {
      y = height - r - 3;
      vx *= fk;
      vy *= -fb;
    }
    if ( y + vy - r < 3 )
    {
      y = r + 3;
      vx *= fk;
      vy *= -fb;
    }
    if ( x + vx + r > width-3 )
    {
      x = width - r - 2;
      vx *= -fb;
      vy *= fk;
    }
    if ( x + vx - r < 3 )
    {
      x = r + 3;
      vx *= -fb;
      vy *= fk;
    }
  }
  
  public void fall()
  {
    wx = 0;
    wy = m*fg;
  }

  public void move()
  {
    float fx = tx + wx;
    float fy = ty + wy;
    
    tx = ty = 0;
    
    float ax = fx/m;
    float ay = fy/m;
    
    vx += f*ax;
    vy += f*ay;
    
    vx *= fd;
    vy *= fd;
       
    if ( ( x + vx < width - r || vx <= 0 ) && ( x + vx > r || vx >= 0 ) )
    {
      x += vx;
    }
    else
    {
      vx = 0;
    }
    if ( ( y + vy < height - r || vy <= 0 ) && ( y + vy > r || vy >= 0 ) )
    {
      y += vy;
    }
    else
    {
      vy = 0;
    }
  }
  
  public void checkClick()
  {
    if ( over() )
    {
      locked = true;
    }
  }
   
  public void drag()
  {
    if ( !mousePressed )
    {
      locked = false;
    }
    if ( locked )
    {
      assignPos(mouseX, mouseY);
    }
  }
  
  public void assignPos( float X, float Y )
  {
    x = X;
    y = Y;
    
    tx = ty = wx = wy = vx = vy = 0;
  }
  
  public boolean over() 
  { 
    if( mouseX > x - 2*r && mouseX < x + 2*r && mouseY > y - 2*r && mouseY < y + 2*r ) 
    { 
      return true; 
    } 
    else
    { 
      return false; 
    } 
  }
}

// ------------------------------------------------------------------------------
// Springs - http://www.arkitus.com
// Copyright (C) 2005  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Spring.java
// Something that connects two springs together.
// ------------------------------------------------------------------------------

class Spring
{
  int o1;
  int o2;
  float l;
  
  Spring( int O1, int O2, float L )
  {
    o1 = O1;
    o2 = O2;
    l = L;
  }
  
  public void pull()
  {
    float x1 = Objects[o1].x;
    float y1 = Objects[o1].y;
    float x2 = Objects[o2].x;
    float y2 = Objects[o2].y;
    
    float deltax = x2 - x1;
    float deltay = y2 - y1;
    
    if ( deltax == 0 )
    {
      deltax = random(-10,10);
    }
    if ( deltay == 0 )
    {
      deltay = random(-10,10);
    }
    
    float d = sqrt(pow(deltax,2)+pow(deltay,2));
    float theta = atan2(deltay, deltax);
    
    float extensionx = (d - l*fl)*cos(theta);
    float extensiony = (d - l*fl)*sin(theta);
    
    Objects[o1].tx += +fr*extensionx/2;
    Objects[o1].ty += +fr*extensiony/2;
    Objects[o2].tx += -fr*extensionx/2;
    Objects[o2].ty += -fr*extensiony/2;
  }
  
  public void display()
  {
    stroke(150,150,150);
    strokeWeight(2);
    line(Objects[o1].x, Objects[o1].y, Objects[o2].x, Objects[o2].y);
  }
}
static public void main(String args[]) {   PApplet.main(new String[] { "Springs" });}}